import type { GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, ChannelEncodeType, CirclepackingEncodeChannels, WithDefaultEncode, PlotCirclePackingEncodeSpec, SemanticLabelOption } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
import type { ITextAttribute } from '@visactor/vrender-core';
export declare class CirclePackingSemanticMark extends SemanticMark<PlotCirclePackingEncodeSpec, CirclepackingEncodeChannels> {
    static readonly type = PlotMakType.circlePacking;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultDataTransform(): TransformSpec[];
    parseScaleByEncode(channel: CirclepackingEncodeChannels, option: ValueOf<WithDefaultEncode<PlotCirclePackingEncodeSpec, CirclepackingEncodeChannels>, CirclepackingEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotCirclePackingEncodeSpec, CirclepackingEncodeChannels>): GenerateBaseEncodeSpec<PlotCirclePackingEncodeSpec>;
    setMainMarkSpec(): {
        key: string;
    };
    protected setLabelTextGetter(channel: string, option: SemanticLabelOption | boolean): ChannelEncodeType<ITextAttribute['text']>;
}
